@echo off
set PATCH_TYPE=interim fix
set PATCH_NAME=5.2.0.3-TIV-ITDS-Win32-IF0007
set IDS_NAME=IBM Tivoli Directory Server v5.2
set IDS_EXE=ibmslapd
set IDS_DIRADM_NAME=ibmdiradm
title Install %PATCH_TYPE% %PATCH_NAME%

if not "%1"=="/?" goto NO_HELP
echo This command will install %PATCH_TYPE% %PATCH_NAME% for %IDS_NAME%
echo Use "no_prompt" to not prompt for confirmation or exit status.
goto :NO_EXT_END

rem =============================================================
:NO_HELP
rem Do not prompt for confirmation - just run
if "%1"=="no_prompt" goto START

rem =============================================================
echo This command will install %PATCH_TYPE% %PATCH_NAME% for %IDS_NAME%
echo.
echo The %IDS_NAME% needs to be stoped before continuing.
if "%IDS_DIRADM_NAME%" == "" goto NODIRADM
echo.
echo Please also stop the %IDS_NAME% Admin Daemon
echo (from the services panel).
:NODIRADM
echo.
echo Press ^<CTRL^>-C to cancel, or 
pause

rem =============================================================
:START
VERIFY OTHER 2>nul
setlocal enableextensions
if not errorlevel 1 goto EXTENSIONS_ENABLED
echo.
echo CMD.EXE must support command extensions
echo The %PATCH_TYPE% will not be installed.
echo.
if not "%1"=="no_prompt" pause
goto END

rem =============================================================
:EXTENSIONS_ENABLED
set CALLED_FROM_INSTALL=TRUE
if "%1"=="no_prompt" set NO_PROMPT=TRUE
if exist install_update.bat goto FOUND_PATCH_DIR
( pushd "%~dp0" 2>NUL ) && goto FOUND_PATCH_DIR
echo Unable to change to the directory where the where %PATCH_NAME%.zip was extracted.
echo Please change to that directory before running install.
echo.
echo The %PATCH_TYPE% will not be installed.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END


rem =============================================================
:FOUND_PATCH_DIR
if exist "%LDAPHome%" goto FOUND_LDAPHome
echo Unable to locate LDAP install directory
echo LDAPHome = %LDAPHome%
echo The %PATCH_TYPE% will not be installed.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:FOUND_LDAPHome
ldtrc off 2>&1 2>NUL
if exist "%LDAPHome%\bin\ldapsearch.exe" goto FOUND_Client
echo Unable to locate LDAP client
echo %LDAPHome%\bin\ldapsearch.exe not found
echo The fix pack will not be installed.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:FOUND_Client
set INSTALL_TYPE=client
set INSTALL_DESC=client
if exist "%LDAPHome%\bin\%IDS_EXE%.exe" goto FOUND_Server
if exist data\all_files.list goto BACKUP
echo data\all_files.list not found
echo The %PATCH_TYPE% will not be installed.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:FOUND_Server
set INSTALL_TYPE=server
set INSTALL_DESC=client and server
if exist data\all_files.list goto BACKUP
echo data\all_files.list not found
echo The %PATCH_TYPE% will not be installed.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:BACKUP
if exist data\UNDO goto APPLY_PATCH
if not exist data\UNDO_IN_PROGRESS goto INIT_BACKUP
echo rd /s /q data\UNDO_IN_PROGRESS >data\error.txt
( rd /s /q data\UNDO_IN_PROGRESS 2>>data\error.txt ) || goto BACKUP_ERROR


rem =============================================================
:INIT_BACKUP
del /f /q data\error.txt 2>NUL
echo mkdir data\UNDO_IN_PROGRESS\bin\locale\dssuconvtab >>data\error.txt
( md data\UNDO_IN_PROGRESS\bin\locale\dssuconvtab 2>>data\error.txt ) || goto BACKUP_ERROR
echo mkdir data\UNDO_IN_PROGRESS\config >>data\error.txt
( md data\UNDO_IN_PROGRESS\config 2>>data\error.txt ) || goto BACKUP_ERROR
echo mkdir data\UNDO_IN_PROGRESS\examples >>data\error.txt
( md data\UNDO_IN_PROGRESS\examples 2>>data\error.txt ) || goto BACKUP_ERROR
echo mkdir data\UNDO_IN_PROGRESS\include >>data\error.txt
( md data\UNDO_IN_PROGRESS\include 2>>data\error.txt ) || goto BACKUP_ERROR
echo mkdir data\UNDO_IN_PROGRESS\lib >>data\error.txt
( md data\UNDO_IN_PROGRESS\lib 2>>data\error.txt ) || goto BACKUP_ERROR
echo mkdir data\UNDO_IN_PROGRESS\web\cgi-bin >>data\error.txt
( md data\UNDO_IN_PROGRESS\web\cgi-bin 2>>data\error.txt ) || goto BACKUP_ERROR
echo mkdir data\UNDO_IN_PROGRESS\web\enus1252\config >>data\error.txt
( md data\UNDO_IN_PROGRESS\web\enus1252\config 2>>data\error.txt ) || goto BACKUP_ERROR

echo Backing up existing %INSTALL_DESC% files...
del /f /q data\error.txt 2>NUL
for /F %%f in (data\all_files.list) do call :BACKUP_FILE %%f
if exist data\error.txt goto BACKUP_ERROR
( ren data\UNDO_IN_PROGRESS UNDO 2>data\error.txt ) || goto BACKUP_ERROR
goto APPLY_PATCH

rem =============================================================
:BACKUP_ERROR
echo Unexpected error while backing up existing files:
echo ---------------------------------------
type data\error.txt
echo ---------------------------------------
echo.
echo The %PATCH_TYPE% will not be installed.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:BACKUP_FILE
if exist data\error.txt goto :EOF
if "%1"=="" (echo %%1 is blank) && goto :EOF
if not exist "%LDAPHome%\%1" goto :EOF
echo Backing up %LDAPHome%\%1
( copy /v "%LDAPHome%\%1" data\UNDO_IN_PROGRESS\%1 2>&1 >data\error.tmp ) || ren data\error.tmp error.txt
goto :EOF

rem =============================================================
:APPLY_PATCH
echo.
echo Existing files are saved in the data\UNDO folder.

echo Installing %PATCH_TYPE% %PATCH_NAME%...
del /f /q data\error.txt 2>NUL
del /f /q data\undo_files.list 2>NUL
del /f /q data\installed_files.list 2>NUL
for /F %%f in (data\all_files.list) do call :PATCH_FILE %%f REPLACE
call :PATCH_FILE bin\%PATCH_NAME%.txt ADD
if exist data\error.txt goto PATCH_ERROR
ren data\undo_files.list installed_files.list
echo.
echo %PATCH_NAME% for %IDS_NAME% has been successfully installed.
echo The previous version can be restored by running uninstall_update.bat.
echo.
if not "%NO_PROMPT%"=="TRUE" pause
goto END

rem =============================================================
:PATCH_FILE
if exist data\error.txt goto :EOF
if "%2"=="ADD" goto ADD_PATCH_FILE
if not exist "%LDAPHome%\%1" goto :EOF

echo Replacing "%LDAPHome%\%1"
goto COPY_PATCH_FILE

:ADD_PATCH_FILE
echo Adding "%LDAPHome%\%1"

:COPY_PATCH_FILE
echo copy /v "data\%1" "%LDAPHome%\%1" >data\error.tmp
( (copy /v "data\%1" "%LDAPHome%\%1" 2>&1) >>data\error.tmp ) || ren data\error.tmp error.txt
if not exist data\error.txt (echo %1 >> data\undo_files.list)
goto :EOF

rem =============================================================
:PATCH_ERROR
echo Unexpected error while installing %INSTALL_DESC% files:
echo ---------------------------------------
type data\error.txt
echo ---------------------------------------
echo.
echo Be sure all client and server processes are stopped before applying the patch.
echo.
echo Restoring original %INSTALL_DESC% files from backup...
echo.
call .\uninstall_update.bat %NO_PROMPT%
echo.
echo ---------------------------------------
echo The %PATCH_TYPE% has not been installed.
echo.
goto END

rem =============================================================
:END
popd
endlocal

:NO_EXT_END
